'From Squeak3.2 of 11 July 2002 [latest update: #4956] on 23 August 2002 at 2:49:48 am'!
"Change Set:		SimulatorFixes-ajh
Date:			23 August 2002
Author:			Anthony Hannan (ajh18@cornell.edu)

This changeset fixes the InterpreterSimulator so it can simulate full-size images.  However, the image must have been saved inside an MVC project.  Simulating a morphic project works but the display is black"!

Object subclass: #CArray
	instanceVariableNames: 'interpreter arrayBaseAddress ptrOffset unitSize '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMConstruction-Plugins'!

!CArray commentStamp: '<historical>' prior: 0!
For Simulating the Interpreter only.  Coercing an Integer to a pointer (eg. cCoerce:to: 'char *') returns a CArray.  A CArray responds to at: and at:put: by reading/writing from the memory of the interpreter that sent the cCoerce:to: message in the first place.  A CArray responds to arithmetic by returning the new address.  Since longAt: sends // to its given address this is where the CArray converts back to a Integer for the memory fetch to work.!

Interpreter subclass: #InterpreterSimulator
	instanceVariableNames: 'byteCount sendCount traceOn myBitBlt displayForm filesOpen imageName pluginList mappedPluginEntries inputSem quitBlock '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMConstruction-Interpreter'!

!CArray methodsFor: 'int arithmetic' stamp: 'ajh 8/20/2002 00:35'!
* n

	^ self ptrAddress * n! !

!CArray methodsFor: 'int arithmetic' stamp: 'ajh 8/20/2002 01:43'!
+ n

	^ self ptrAddress + n! !

!CArray methodsFor: 'int arithmetic' stamp: 'ajh 8/20/2002 01:43'!
- n

	^ self ptrAddress - n! !

!CArray methodsFor: 'int arithmetic' stamp: 'ajh 8/20/2002 00:35'!
// n

	^ self ptrAddress // n! !

!CArray methodsFor: 'int arithmetic' stamp: 'ajh 8/20/2002 00:35'!
<< n

	^ self ptrAddress bitShift: n! !

!CArray methodsFor: 'int arithmetic' stamp: 'ajh 8/20/2002 00:35'!
>> n

	^ self ptrAddress bitShift: 0 - n! !

!CArray methodsFor: 'int arithmetic' stamp: 'ajh 8/20/2002 00:35'!
bitAnd: n

	^ self ptrAddress bitAnd: n! !

!CArray methodsFor: 'int arithmetic' stamp: 'ajh 8/20/2002 00:35'!
bitOr: n

	^ self ptrAddress bitOr: n! !

!CArray methodsFor: 'int arithmetic' stamp: 'ajh 8/20/2002 00:35'!
bitShift: n

	^ self ptrAddress bitShift: n! !

!CArray methodsFor: 'pointer arithmetic' stamp: 'ajh 8/20/2002 01:34'!
+= increment

	ptrOffset _ ptrOffset + increment! !

!CArray methodsFor: 'pointer arithmetic' stamp: 'ajh 8/20/2002 01:35'!
-= decrement

	ptrOffset _ ptrOffset - decrement! !

!CArray methodsFor: 'accessing' stamp: 'ajh 8/20/2002 00:56'!
at: offset

	ptrOffset = 0 ifFalse: [self error: 'only expect base address to receive at: message'].
	unitSize = 1 ifTrue: [^ interpreter byteAt: arrayBaseAddress + offset].
	unitSize = 4 ifTrue: [^ interpreter longAt: arrayBaseAddress + (offset * 4)].
	self halt: 'Can''t handle unitSize ', unitSize printString
! !

!CArray methodsFor: 'accessing' stamp: 'ajh 8/20/2002 00:57'!
at: offset put: val

	ptrOffset = 0 ifFalse: [self error: 'only expect base address to receive at:put: message'].
	unitSize = 1 ifTrue: [^ interpreter byteAt: arrayBaseAddress + offset put: val].
	unitSize = 4 ifTrue: [^ interpreter longAt: arrayBaseAddress + (offset * 4) put: val].
	self halt: 'Can''t handle unitSize ', unitSize printString
! !

!CArray methodsFor: 'converting' stamp: 'ajh 8/20/2002 01:29'!
adaptToNumber: rcvr andSend: selector

	^ rcvr perform: selector with: self asInteger! !

!CArray methodsFor: 'converting' stamp: 'ajh 8/20/2002 01:10'!
asInteger

	^ self ptrAddress! !

!CArray methodsFor: 'converting' stamp: 'ajh 8/20/2002 00:48'!
coerceTo: cTypeString sim: interpreterSimulator

	cTypeString = 'int' ifTrue: [^ self ptrAddress].
	^ self! !

!CArray methodsFor: 'converting' stamp: 'ajh 8/20/2002 01:23'!
doesNotUnderstand: message

	^ self asInteger perform: message selector withArguments: message arguments! !

!CArray methodsFor: 'private' stamp: 'ajh 8/20/2002 00:30'!
interpreter: interpreterSimulator address: arrayAddress unitSize: numBytes

	interpreter _ interpreterSimulator.
	arrayBaseAddress _ arrayAddress.
	unitSize _ numBytes.
	ptrOffset _ 0.
! !

!CArray methodsFor: 'private' stamp: 'ajh 8/20/2002 00:36'!
ptrAddress

	^ arrayBaseAddress + ptrOffset! !


!CObjectAccessor methodsFor: 'converting' stamp: 'ajh 8/20/2002 01:16'!
coerceTo: cTypeString sim: interpreterSimulator

	^ self! !


!FilePlugin methodsFor: 'file primitives' stamp: 'ajh 8/20/2002 02:05'!
primitiveFileSetPosition
	| newPosition file sz |
	self var: 'file' declareC: 'SQFile *file'.
	self var: 'newPosition' type: 'squeakFileOffsetType'.
	self export: true.
	(interpreterProxy isIntegerObject: (interpreterProxy stackValue: 0)) ifFalse:
		[sz _ self cCode: 'sizeof(squeakFileOffsetType)'.
		(interpreterProxy byteSizeOf: (interpreterProxy stackValue: 0)) > sz 
			ifTrue: [^interpreterProxy primitiveFail]].
	newPosition _ interpreterProxy positive64BitValueOf: (interpreterProxy stackValue: 0).
	file _ self fileValueOf: (interpreterProxy stackValue: 1).
	interpreterProxy failed ifFalse:[
		self sqFile: file SetPosition: newPosition ].
	interpreterProxy failed ifFalse:[
		interpreterProxy pop: 2 "pop position, file; leave rcvr on stack" ].! !

!FilePlugin methodsFor: 'file primitives' stamp: 'ajh 8/20/2002 02:06'!
primitiveFileTruncate
	| truncatePosition file sz |
	self var: 'file' declareC: 'SQFile *file'.
	self var: 'truncatePosition' type: 'squeakFileOffsetType'.
	self export: true.
	(interpreterProxy isIntegerObject: (interpreterProxy stackValue: 0)) ifFalse:
		[sz _ self cCode: 'sizeof(squeakFileOffsetType)'.
		(interpreterProxy byteSizeOf: (interpreterProxy stackValue: 0)) > sz 
			ifTrue: [^interpreterProxy primitiveFail]].
	truncatePosition _ interpreterProxy positive64BitValueOf: (interpreterProxy stackValue: 0).
	file _ self fileValueOf: (interpreterProxy stackValue: 1).
	interpreterProxy failed ifFalse:[
		self sqFile: file Truncate: truncatePosition ].
	interpreterProxy failed ifFalse:[
		interpreterProxy pop: 2 "pop position, file; leave rcvr on stack" ].! !

!FilePlugin methodsFor: 'security primitives' stamp: 'ajh 8/21/2002 22:11'!
primitiveHasFileAccess
	|  hasAccess |
	self export: true.
	"If the security plugin can be loaded, use it to check . 
	If not, assume 
	it's ok"
	sHFAfn ~= 0
		ifTrue: [hasAccess _ self cCode: ' ((int (*) (void)) sHFAfn)()' inSmalltalk: [true]]
		ifFalse: [hasAccess _ true].
	interpreterProxy pop: 1.
	interpreterProxy pushBool: hasAccess! !


!Integer methodsFor: 'interpreter simulator' stamp: 'ajh 8/20/2002 00:58'!
coerceTo: cTypeString sim: interpreter

	cTypeString last = $* ifTrue: [  "C pointer"
		^ CArray new interpreter: interpreter address: self unitSize:
			((cTypeString first: 4) = 'char' ifTrue: [1] ifFalse: [4])
	].
	^ self  "C number (int, char, float, etc)"! !


!InterpreterPlugin class methodsFor: 'accessing' stamp: 'ajh 8/21/2002 21:43'!
simulatorClass
	"For running from Smalltalk - answer a class that can be used to simulate the receiver, or nil if you want the primitives in this module to always fail, causing simulation to fall through to the Smalltalk code.  By default every non-TestInterpreterPlugin can simulate itself."

	^ self! !


!InterpreterSimulator methodsFor: 'initialization' stamp: 'ajh 8/23/2002 02:36'!
initialize

	"Initialize the InterpreterSimulator when running the interpreter inside
	Smalltalk. The primary responsibility of this method is to allocate
	Smalltalk Arrays for variables that will be declared as statically-allocated
	global arrays in the translated code."

	"initialize class variables"
	ObjectMemory initialize.
	Interpreter initialize.

	methodCache _ Array new: MethodCacheSize.
	atCache _ Array new: AtCacheTotalSize.
	self flushMethodCache.
	rootTable _ Array new: RootTableSize.
	remapBuffer _ Array new: RemapBufferSize.
	semaphoresUseBufferA _ true.
	semaphoresToSignalA _ Array new: SemaphoresToSignalSize.
	semaphoresToSignalB _ Array new: SemaphoresToSignalSize.
	externalPrimitiveTable _ CArrayAccessor on: (Array new: MaxExternalPrimitiveTableSize).

	obsoleteNamedPrimitiveTable _ CArrayAccessor on: 
		((self class obsoleteNamedPrimitiveTable copyWith: {nil. nil. nil})
			collect: [:spec | CArrayAccessor on: (spec
				collect: [:string | string ifNotNil: [CArrayAccessor on: string]])]).
	obsoleteIndexedPrimitiveTable _ CArrayAccessor on: 
		(self class obsoleteIndexedPrimitiveTable collect: [:spec | 
			CArrayAccessor on:
				(spec ifNil:[Array new: 3] 
					  ifNotNil:[Array with: spec first with: spec second with: nil])]).
	pluginList _ #().
	mappedPluginEntries _ #().

	"initialize InterpreterSimulator variables used for debugging"
	byteCount _ 0.
	sendCount _ 0.
	traceOn _ true.
	myBitBlt _ BitBltSimulator new setInterpreter: self.
	displayForm _ Form extent: 640@480 depth: 8.
		"displayForm is created in response to primitiveBeDisplay, but one is need for showDisplayBits:w:h:d:left:right:top:bottom: during DoAssertionChecks"
	filesOpen _ OrderedCollection new.
! !

!InterpreterSimulator methodsFor: 'testing' stamp: 'ajh 8/21/2002 22:41'!
ioExit

	quitBlock value  "Cause return from #test"! !

!InterpreterSimulator methodsFor: 'testing' stamp: 'ajh 8/21/2002 22:32'!
test
	Transcript clear.
	byteCount _ 0.
	quitBlock _ [^ self].
	self internalizeIPandSP.
	self fetchNextBytecode.
	[true] whileTrue:
		[self dispatchOn: currentBytecode in: BytecodeTable.
		byteCount _ byteCount + 1].
	self externalizeIPandSP.
! !

!InterpreterSimulator methodsFor: 'I/O primitives support' stamp: 'ajh 8/21/2002 22:09'!
sizeof: var

	^ 4! !

!InterpreterSimulator methodsFor: 'memory access' stamp: 'ajh 8/20/2002 00:49'!
cCoerce: value to: cTypeString
	"Type coercion for translation only; just return the value when running in Smalltalk."

	^ value coerceTo: cTypeString sim: self! !

!InterpreterSimulator methodsFor: 'memory access' stamp: 'ajh 8/19/2002 19:18'!
sqGrowMemory: oldLimit By: delta

	memory _ memory copyGrownBy: delta // 4.
	^ memory size * 4! !

!InterpreterSimulator methodsFor: 'memory access' stamp: 'ajh 8/19/2002 19:18'!
sqShrinkMemory: oldLimit By: delta

	^ oldLimit! !


!SecurityPlugin methodsFor: 'primitives' stamp: 'ajh 10/22/2001 10:52'!
primitiveCanWriteImage
	self export: true.
	interpreterProxy pop: 1.
	interpreterProxy pushBool: interpreterProxy ioCanWriteImage.! !

!SecurityPlugin methodsFor: 'primitives' stamp: 'ajh 10/22/2001 11:01'!
primitiveGetSecureUserDirectory
	"Primitive. Return the secure directory for the current user."
	| dirName dirLen dirOop dirPtr |
	self export: true.
	self var: #dirName type: 'char *'.
	self var: #dirPtr type: 'char *'.
	dirName _ self cCode: 'ioGetSecureUserDirectory()' inSmalltalk: [nil].
	(dirName == nil or:[interpreterProxy failed]) 
		ifTrue:[^interpreterProxy primitiveFail].
	dirLen _ self strlen: dirName.
	dirOop _ interpreterProxy instantiateClass: interpreterProxy classString indexableSize: dirLen.
	interpreterProxy failed ifTrue:[^nil].
	dirPtr _ interpreterProxy firstIndexableField: dirOop.
	0 to: dirLen-1 do:[:i|
		dirPtr at: i put: (dirName at: i)].
	interpreterProxy pop: 1.
	interpreterProxy push: dirOop.! !


!SequenceableCollection methodsFor: 'copying' stamp: 'ajh 8/19/2002 19:15'!
copyGrownBy: delta
	"Return a copy of self whose size is larger by delta.  The new elements will be filled in with nil or zero depending on the type of class (holds pointers or bytes/words)"

	| copy |
	copy _ self species ofSize: self size + delta.
	copy replaceFrom: 1 to: self size with: self startingAt: 1.
	^ copy! !


!Bitmap methodsFor: 'interpreter simulator' stamp: 'ajh 8/20/2002 01:13'!
coerceTo: cTypeString sim: interpreter

	^ self! !


!TestInterpreterPlugin class methodsFor: 'instance creation' stamp: 'ajh 8/21/2002 21:42'!
doPrimitive: primitiveName withArguments: argArray
	| proxy plugin |
	proxy _ InterpreterProxy new.
	proxy loadStackFrom: thisContext sender.
	plugin _ (self simulatorClass ifNil: [self]) new.
	plugin setInterpreter: proxy.
	^plugin perform: primitiveName asSymbol withArguments: argArray! !

!TestInterpreterPlugin class methodsFor: 'instance creation' stamp: 'ajh 8/21/2002 21:45'!
simulatorClass
	"For running from Smalltalk - answer a class that can be used to simulate the receiver, or nil if you want the primitives in this module to always fail, causing simulation to fall through to the Smalltalk code.
	By default TestInterpreterPlugin answers nil because methods in these plugins are intended to be embedded in code that pushes and pops from the stack and therefore cannot be run independently.  This wrapper code is generated when translated to C.  But, unfortunately, this code is missing during simulation.  There was an attempt to simulate this, but only the prologue code (getting arg from the stack) is simulated (see simulatePrologInContext:). The epologue code (popping args and pushing result) is not.  So I am making this nil until this can be fixed.
	Also, beware that primitive methods that take no args exactly match their primitive name (faking out InterpreterSimulator>>callExternalPrimitive:).  They should only be called from within wrapper code that simulates the prologue and epilogue.  Primitive method that take args don't have this accidental matching problem since their names contain colons while their primitive names do not. - ajh 8/21/2002"

	^ nil! !

InterpreterSimulator removeSelector: #sqGrowObjectMemory:By:!
InterpreterSimulator removeSelector: #sqShrinkObjectMemory:By:!
